/*
 * Unique Schlüssel für JPA Entität
 */
package de.ivu.elect.business.wahlbeteiligung.entity;
import java.util.function.Function;
import java.util.ArrayList;
import java.util.stream.Collectors;

@javax.enterprise.inject.Vetoed
public class WahlbeteiligungAuswertungUK
implements de.ivu.elect.jee.entity.tk.EntityUK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

    protected final java.util.Date datum;

    public java.util.Date getDatum(){
      return datum;
    }

  protected final de.ivu.elect.business.wahl.entity.WahlUK wahlUK;

    public de.ivu.elect.business.wahl.entity.WahlUK getWahlUK(){
      return wahlUK;
    }

  public WahlbeteiligungAuswertungUK(
java.util.Date datum
,   de.ivu.elect.business.wahl.entity.WahlUK wahlUK
  ) {
    super();


      this.datum = datum;
        this.wahlUK = wahlUK;
    }

  @Override
  public int hashCode() {
        int result = 1;
    
    
                    result = result + ((datum == null) ? 0 : datum.hashCode());
        
                    result = result + ((wahlUK == null) ? 0 : wahlUK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    
    if (getClass() != obj.getClass()) {
      return false;
    }

            WahlbeteiligungAuswertungUK other = (WahlbeteiligungAuswertungUK) obj;

                if (datum == null) {
          if (other.datum != null) {
            return false;
          }
        } else if (!datum.equals(other.datum)) {
          return false;
        }
        
                if (wahlUK == null) {
          if (other.wahlUK != null) {
            return false;
          }
        } else if (!wahlUK.equals(other.wahlUK)) {
          return false;
        }
            
    return true;
  }

  @Override
  public String getEntityMessageKey() {
    return WahlbeteiligungAuswertungConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(wahlUK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(WahlbeteiligungAuswertungConstants.MESSAGE_KEY_ENTITY_EINZAHL, WahlbeteiligungAuswertungConstants.MESSAGE_KEY_DATUM_EINZAHL, datum));
        
        return result;
      }
  
    @Override
  public String toString() {
    return "WahlbeteiligungAuswertungUK[" + toStringParameter() + "]";
  }

            protected String toStringParameter() {
              String result = ""

                                                        +"datum="+datum
                                        +", "                +"wahlUK="+wahlUK
                        ;
                          return result;
            
            }




          public String allUKFields() {
    return String.join(", ", getAllUKFieldValues().stream()
         .map(object -> (object != null ? object.toString() : null))
         .collect(Collectors.toList()));
    }

   protected ArrayList<Object> getAllUKFieldValues() {
              ArrayList<Object> list = new ArrayList<>();
              list.add(datum);
     return list;
   }

            public static <E extends WahlbeteiligungAuswertung> java.util.Map<WahlbeteiligungAuswertungUK, E> mappeWahlbeteiligungAuswertungNachUK(java.util.Collection<E> entities) {

                return entities.stream().collect(java.util.stream.Collectors.toMap(WahlbeteiligungAuswertung::getWahlbeteiligungAuswertungUK, Function.<E>identity(), (u,v)->v));
             }


                public static Function<WahlbeteiligungAuswertung, WahlbeteiligungAuswertungUK> getWahlbeteiligungAuswertungToUKFunction() {
                return WahlbeteiligungAuswertung::getWahlbeteiligungAuswertungUK;
                }

}
